##// END OF EJS Templates
error on indentation o
vidal -
r757:b039913c8017
parent child
Show More
@@ -1,922 +1,922
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=3P}
43 RPI_MODEL=${RPI_MODEL:=3P}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47 if [ $RELEASE = "bullseye" ] ; then
47 if [ $RELEASE = "bullseye" ] ; then
48 RELEASE=testing
48 RELEASE=testing
49 fi
49 fi
50
50
51 # Kernel Branch
51 # Kernel Branch
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53
53
54 # URLs
54 # URLs
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64
64
65 # Kernel deb packages for 32bit kernel
65 # Kernel deb packages for 32bit kernel
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.102.20200211/bcmrpi3-kernel-bis-4.19.102.20200211.tar.xz}
69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.102.20200211/bcmrpi3-kernel-bis-4.19.102.20200211.tar.xz}
70 # Default precompiled 64bit kernel
70 # Default precompiled 64bit kernel
71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.102.20200211/bcmrpi3-kernel-4.19.102.20200211.tar.xz}
71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.102.20200211/bcmrpi3-kernel-4.19.102.20200211.tar.xz}
72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
76 # Generic
76 # Generic
77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81
81
82 # Build directories
82 # Build directories
83 WORKDIR=$(pwd)
83 WORKDIR=$(pwd)
84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 BUILDDIR="${BASEDIR}/build"
85 BUILDDIR="${BASEDIR}/build"
86
86
87 # Chroot directories
87 # Chroot directories
88 R="${BUILDDIR}/chroot"
88 R="${BUILDDIR}/chroot"
89 ETC_DIR="${R}/etc"
89 ETC_DIR="${R}/etc"
90 LIB_DIR="${R}/lib"
90 LIB_DIR="${R}/lib"
91 BOOT_DIR="${R}/boot/firmware"
91 BOOT_DIR="${R}/boot/firmware"
92 KERNEL_DIR="${R}/usr/src/linux"
92 KERNEL_DIR="${R}/usr/src/linux"
93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95
95
96 # APT settings
96 # APT settings
97 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
97 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
98 APT_PROXY=${APT_PROXY:=""}
98 APT_PROXY=${APT_PROXY:=""}
99 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
99 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
100 # Packages required in the chroot build environment
100 # Packages required in the chroot build environment
101 APT_INCLUDES=${APT_INCLUDES:=""}
101 APT_INCLUDES=${APT_INCLUDES:=""}
102 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
102 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
103 # Packages to exclude from chroot build environment
103 # Packages to exclude from chroot build environment
104 APT_EXCLUDES=${APT_EXCLUDES:=""}
104 APT_EXCLUDES=${APT_EXCLUDES:=""}
105
105
106 # General settings
106 # General settings
107 SET_ARCH=${SET_ARCH:=32}
107 SET_ARCH=${SET_ARCH:=32}
108 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
108 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
109 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
109 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
110 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
110 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
111 EXPANDROOT=${EXPANDROOT:=true}
111 EXPANDROOT=${EXPANDROOT:=true}
112
112
113 ENABLE_ROOT=${ENABLE_ROOT:=false}
113 ENABLE_ROOT=${ENABLE_ROOT:=false}
114 ROOT_PASSWORD=${ROOT_PASSWORD:=raspberry}
114 ROOT_PASSWORD=${ROOT_PASSWORD:=raspberry}
115 ENABLE_USER=${ENABLE_USER:=true}
115 ENABLE_USER=${ENABLE_USER:=true}
116 USER_NAME=${USER_NAME:="pi"}
116 USER_NAME=${USER_NAME:="pi"}
117 USER_PASSWORD=${USER_PASSWORD:=raspberry}
117 USER_PASSWORD=${USER_PASSWORD:=raspberry}
118
118
119 # Keyboard settings
119 # Keyboard settings
120 XKB_MODEL=${XKB_MODEL:=""}
120 XKB_MODEL=${XKB_MODEL:=""}
121 XKB_LAYOUT=${XKB_LAYOUT:=""}
121 XKB_LAYOUT=${XKB_LAYOUT:=""}
122 XKB_VARIANT=${XKB_VARIANT:=""}
122 XKB_VARIANT=${XKB_VARIANT:=""}
123 XKB_OPTIONS=${XKB_OPTIONS:=""}
123 XKB_OPTIONS=${XKB_OPTIONS:=""}
124
124
125 # Networking settings:
125 # Networking settings:
126 ENABLE_IPV6=${ENABLE_IPV6:=true}
126 ENABLE_IPV6=${ENABLE_IPV6:=true}
127 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
127 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
128 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
128 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
129 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
129 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
130 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
130 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
131
131
132 # Network settings (DHCP)
132 # Network settings (DHCP)
133 ENABLE_ETH_DHCP=${ENABLE_ETH_DHCP:=true}
133 ENABLE_ETH_DHCP=${ENABLE_ETH_DHCP:=true}
134 ENABLE_WIFI_DHCP=${ENABLE_ETH_DHCP:=true}
134 ENABLE_WIFI_DHCP=${ENABLE_ETH_DHCP:=true}
135
135
136 # Network settings (static)
136 # Network settings (static)
137 NET_ETH_ADDRESS=${NET_ETH_ADDRESS:=""}
137 NET_ETH_ADDRESS=${NET_ETH_ADDRESS:=""}
138 NET_ETH_GATEWAY=${NET_ETH_GATEWAY:=""}
138 NET_ETH_GATEWAY=${NET_ETH_GATEWAY:=""}
139 NET_ETH_DNS_1=${NET_ETH_DNS_1:=""}
139 NET_ETH_DNS_1=${NET_ETH_DNS_1:=""}
140 NET_ETH_DNS_2=${NET_ETH_DNS_2:=""}
140 NET_ETH_DNS_2=${NET_ETH_DNS_2:=""}
141 NET_ETH_DNS_DOMAINS=${NET_ETH_DNS_DOMAINS:=""}
141 NET_ETH_DNS_DOMAINS=${NET_ETH_DNS_DOMAINS:=""}
142 NET_ETH_NTP_1=${NET_ETH_NTP_1:=""}
142 NET_ETH_NTP_1=${NET_ETH_NTP_1:=""}
143 NET_ETH_NTP_2=${NET_ETH_NTP_2:=""}
143 NET_ETH_NTP_2=${NET_ETH_NTP_2:=""}
144
144
145 # Networking settings (WIFI):
145 # Networking settings (WIFI):
146 NET_WIFI_SSID=${NET_WIFI_SSID:=""}
146 NET_WIFI_SSID=${NET_WIFI_SSID:=""}
147 NET_WIFI_PSK=${NET_WIFI_PSK:=""}
147 NET_WIFI_PSK=${NET_WIFI_PSK:=""}
148
148
149 # Network settings (static)
149 # Network settings (static)
150 NET_WIFI_ADDRESS=${NET_WIFI_ADDRESS:=""}
150 NET_WIFI_ADDRESS=${NET_WIFI_ADDRESS:=""}
151 NET_WIFI_GATEWAY=${NET_WIFI_GATEWAY:=""}
151 NET_WIFI_GATEWAY=${NET_WIFI_GATEWAY:=""}
152 NET_WIFI_DNS_1=${NET_WIFI_DNS_1:=""}
152 NET_WIFI_DNS_1=${NET_WIFI_DNS_1:=""}
153 NET_WIFI_DNS_2=${NET_WIFI_DNS_2:=""}
153 NET_WIFI_DNS_2=${NET_WIFI_DNS_2:=""}
154 NET_WIFI_DNS_DOMAINS=${NET_WIFI_DNS_DOMAINS:=""}
154 NET_WIFI_DNS_DOMAINS=${NET_WIFI_DNS_DOMAINS:=""}
155 NET_WIFI_NTP_1=${NET_WIFI_NTP_1:=""}
155 NET_WIFI_NTP_1=${NET_WIFI_NTP_1:=""}
156 NET_WIFI_NTP_2=${NET_WIFI_NTP_2:=""}
156 NET_WIFI_NTP_2=${NET_WIFI_NTP_2:=""}
157
157
158 # Feature settings
158 # Feature settings
159 ENABLE_CONSOLE=${ENABLE_CONSOLE:=false}
159 ENABLE_CONSOLE=${ENABLE_CONSOLE:=false}
160 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
160 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
161 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
161 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
162 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
162 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
163 ENABLE_TURBO=${ENABLE_TURBO:=false}
163 ENABLE_TURBO=${ENABLE_TURBO:=false}
164 ENABLE_I2C=${ENABLE_I2C:=false}
164 ENABLE_I2C=${ENABLE_I2C:=false}
165 ENABLE_SPI=${ENABLE_SPI:=false}
165 ENABLE_SPI=${ENABLE_SPI:=false}
166
166
167 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
167 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
168 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
168 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
169 ENABLE_SOUND=${ENABLE_SOUND:=false}
169 ENABLE_SOUND=${ENABLE_SOUND:=false}
170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 ENABLE_XORG=${ENABLE_XORG:=false}
172 ENABLE_XORG=${ENABLE_XORG:=false}
173 ENABLE_WM=${ENABLE_WM:=""}
173 ENABLE_WM=${ENABLE_WM:=""}
174 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
174 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
175 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
175 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
176 ENABLE_LOGO=${ENABLE_LOGO:=true}
176 ENABLE_LOGO=${ENABLE_LOGO:=true}
177 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
177 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
178 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
178 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
179
179
180 # Advanced settings
180 # Advanced settings
181 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
181 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
182 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
182 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
183 ENABLE_QEMU=${ENABLE_QEMU:=false}
183 ENABLE_QEMU=${ENABLE_QEMU:=false}
184 ENABLE_KEYGEN=${ENABLE_KEYGEN:=false}
184 ENABLE_KEYGEN=${ENABLE_KEYGEN:=false}
185 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
185 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
186 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
186 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
187 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
187 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
188 ENABLE_DBUS=${ENABLE_DBUS:=true}
188 ENABLE_DBUS=${ENABLE_DBUS:=true}
189 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
189 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
190 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
190 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
191 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
191 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
192 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
192 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
193 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
193 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
194 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
194 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
195 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
195 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
196 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
196 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
197 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
197 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
198 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
198 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
199
199
200 # SSH settings
200 # SSH settings
201 SSH_ENABLE=${SSH_ENABLE:=true}
201 SSH_ENABLE=${SSH_ENABLE:=true}
202 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
202 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
203 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
203 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
204 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
204 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
205 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
205 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
206 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
206 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
207
207
208 # Kernel compilation settings
208 # Kernel compilation settings
209 BUILD_KERNEL=${BUILD_KERNEL:=true}
209 BUILD_KERNEL=${BUILD_KERNEL:=true}
210 KERNEL_THREADS=${KERNEL_THREADS:=1}
210 KERNEL_THREADS=${KERNEL_THREADS:=1}
211 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
211 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
212 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
212 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
213 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
213 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
214 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
214 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
215 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
215 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
216 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
216 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
217 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
217 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
218 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
218 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
219 KERNELSRC_USRCONFIG=${KERNELSRC_USRCONFIG:=""}
219 KERNELSRC_USRCONFIG=${KERNELSRC_USRCONFIG:=""}
220 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
220 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
221 # Firmware directory: Blank if download from github
221 # Firmware directory: Blank if download from github
222 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
222 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
223 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
223 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
224 KERNEL_NF=${KERNEL_NF:=false}
224 KERNEL_NF=${KERNEL_NF:=false}
225 KERNEL_VIRT=${KERNEL_VIRT:=false}
225 KERNEL_VIRT=${KERNEL_VIRT:=false}
226 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
226 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
227 KERNEL_BPF=${KERNEL_BPF:=false}
227 KERNEL_BPF=${KERNEL_BPF:=false}
228 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
228 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
229 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
229 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
230 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
230 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
231 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
231 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
232 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
232 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
233
233
234 # Reduce disk usage settings
234 # Reduce disk usage settings
235 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
235 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
236 REDUCE_APT=${REDUCE_APT:=true}
236 REDUCE_APT=${REDUCE_APT:=true}
237 REDUCE_DOC=${REDUCE_DOC:=false}
237 REDUCE_DOC=${REDUCE_DOC:=false}
238 REDUCE_MAN=${REDUCE_MAN:=false}
238 REDUCE_MAN=${REDUCE_MAN:=false}
239 REDUCE_VIM=${REDUCE_VIM:=false}
239 REDUCE_VIM=${REDUCE_VIM:=false}
240 REDUCE_BASH=${REDUCE_BASH:=false}
240 REDUCE_BASH=${REDUCE_BASH:=false}
241 REDUCE_HWDB=${REDUCE_HWDB:=false}
241 REDUCE_HWDB=${REDUCE_HWDB:=false}
242 REDUCE_SSHD=${REDUCE_SSHD:=false}
242 REDUCE_SSHD=${REDUCE_SSHD:=false}
243 REDUCE_LOCALE=${REDUCE_LOCALE:=false}
243 REDUCE_LOCALE=${REDUCE_LOCALE:=false}
244 REDUCE_KERNEL=${REDUCE_KERNEL:=false}
244 REDUCE_KERNEL=${REDUCE_KERNEL:=false}
245
245
246 # Encrypted filesystem settings
246 # Encrypted filesystem settings
247 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
247 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
248 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
248 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
249 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
249 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
250 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
250 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
251 CRYPTFS_HASH=${CRYPTFS_HASH:="sha256"}
251 CRYPTFS_HASH=${CRYPTFS_HASH:="sha256"}
252 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=256}
252 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=256}
253 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
253 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
254 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
254 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
255 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
255 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
256 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
256 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
257
257
258 # Packages required for bootstrapping
258 # Packages required for bootstrapping
259 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
259 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
260 MISSING_PACKAGES=""
260 MISSING_PACKAGES=""
261
261
262 # Packages installed for c/c++ build environment in chroot (keep empty)
262 # Packages installed for c/c++ build environment in chroot (keep empty)
263 COMPILER_PACKAGES=""
263 COMPILER_PACKAGES=""
264
264
265 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
265 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
266 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
266 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
267 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
267 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
268 APT_PROXY=http://127.0.0.1:3142/
268 APT_PROXY=http://127.0.0.1:3142/
269 fi
269 fi
270
270
271 # Setup architecture specific settings
271 # Setup architecture specific settings
272 if [ -n "$SET_ARCH" ] ; then
272 if [ -n "$SET_ARCH" ] ; then
273 ## 64-bit configuration
273 ## 64-bit configuration
274 if [ "$SET_ARCH" = 64 ] ; then
274 if [ "$SET_ARCH" = 64 ] ; then
275 ### General 64-bit depended settings
275 ### General 64-bit depended settings
276 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
276 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
277 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
277 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
278 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
278 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
279
279
280 ### Raspberry Pi 64-bit model specific settings
280 ### Raspberry Pi 64-bit model specific settings
281 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
281 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
282 if [ "$RPI_MODEL" != 4 ] ; then
282 if [ "$RPI_MODEL" != 4 ] ; then
283 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
283 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
284 else
284 else
285 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
285 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
286 fi
286 fi
287
287
288 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
288 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
289 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
289 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
290 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
290 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
291 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
291 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
292
292
293 else
293 else
294 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
294 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
295 exit 1
295 exit 1
296 fi
296 fi
297 fi
297 fi
298
298
299 ## 32-bit configuration
299 ## 32-bit configuration
300 if [ "$SET_ARCH" = 32 ] ; then
300 if [ "$SET_ARCH" = 32 ] ; then
301 ### General 32-bit dependend settings
301 ### General 32-bit dependend settings
302 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
302 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
303 KERNEL_ARCH=${KERNEL_ARCH:=arm}
303 KERNEL_ARCH=${KERNEL_ARCH:=arm}
304 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
304 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
305
305
306 ### Raspberry Pi (0-1P) model specific settings
306 ### Raspberry Pi (0-1P) model specific settings
307 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
307 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
308 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
308 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
309 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
309 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
310 RELEASE_ARCH=${RELEASE_ARCH:=armel}
310 RELEASE_ARCH=${RELEASE_ARCH:=armel}
311 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
311 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
312 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
312 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
313 if [ $ENABLE_XORG = true ] ; then
313 if [ $ENABLE_XORG = true ] ; then
314 if [$RELEASE = "stretch" ] || [$RELEASE = "oldstable" ] ; then
314 if [$RELEASE = "stretch" ] || [$RELEASE = "oldstable" ] ; then
315 printf "\nBest support for armel architecture is provided under Debian stretch/oldstable. Choose yes to change release to Debian stretch[y/n] "
315 printf "\nBest support for armel architecture is provided under Debian stretch/oldstable. Choose yes to change release to Debian stretch[y/n] "
316 read -r confirm
316 read -r confirm
317 if [ "$confirm" = "y" ] ; then
317 if [ "$confirm" = "y" ] ; then
318 $RELEASE = "stretch"
318 $RELEASE = "stretch"
319 fi
319 fi
320 fi
320 fi
321 fi
321 fi
322 fi
322 fi
323 ### Raspberry Pi (2-4) model specific settings
323 ### Raspberry Pi (2-4) model specific settings
324 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
324 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
325 if [ "$RPI_MODEL" != 4 ] ; then
325 if [ "$RPI_MODEL" != 4 ] ; then
326 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
326 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
327 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
327 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
328 else
328 else
329 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
329 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
330 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
330 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
331 fi
331 fi
332
332
333 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
333 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
334 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
334 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
335
335
336 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
336 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
337 fi
337 fi
338 fi
338 fi
339
339
340 # SET_ARCH not set
340 # SET_ARCH not set
341 else
341 else
342 echo "error: Please set '32' or '64' as value for SET_ARCH"
342 echo "error: Please set '32' or '64' as value for SET_ARCH"
343 exit 1
343 exit 1
344 fi
344 fi
345 # Device specific configuration and U-Boot configuration
345 # Device specific configuration and U-Boot configuration
346 case "$RPI_MODEL" in
346 case "$RPI_MODEL" in
347 0)
347 0)
348 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
348 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
349 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
349 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
350 ;;
350 ;;
351 1)
351 1)
352 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
352 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
353 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
353 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
354 ;;
354 ;;
355 1P)
355 1P)
356 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
356 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
357 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
357 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
358 ;;
358 ;;
359 2)
359 2)
360 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
360 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
361 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
361 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
362 ;;
362 ;;
363 3)
363 3)
364 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
364 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
365 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
365 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
366 ;;
366 ;;
367 3P)
367 3P)
368 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
368 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
369 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
369 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
370 ;;
370 ;;
371 4)
371 4)
372 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
372 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
373 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
373 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
374 ;;
374 ;;
375 *)
375 *)
376 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
376 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
377 exit 1
377 exit 1
378 ;;
378 ;;
379 esac
379 esac
380
380
381 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
381 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
382 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
382 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
383 ## Include bluetooth packages on supported boards
383 ## Include bluetooth packages on supported boards
384 if [ "$ENABLE_BLUETOOTH" = true ] ; then
384 if [ "$ENABLE_BLUETOOTH" = true ] ; then
385 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
385 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
386 fi
386 fi
387 if [ "$ENABLE_WIRELESS" = true ] ; then
387 if [ "$ENABLE_WIRELESS" = true ] ; then
388 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,wpasupplicant"
388 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,wpasupplicant"
389 fi
389 fi
390 # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
390 # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
391 else
391 else
392 ## Check if the internal wireless interface is not supported by the RPi model
392 ## Check if the internal wireless interface is not supported by the RPi model
393 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
393 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
394 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
394 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
395 exit 1
395 exit 1
396 fi
396 fi
397 fi
397 fi
398
398
399 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
399 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
400 echo "error: You have to compile kernel sources, if you want to enable nexmon"
400 echo "error: You have to compile kernel sources, if you want to enable nexmon"
401 exit 1
401 exit 1
402 fi
402 fi
403
403
404 # Prepare date string for default image file name
404 # Prepare date string for default image file name
405 DATE="$(date +%Y-%m-%d)"
405 DATE="$(date +%Y-%m-%d)"
406 if [ -z "$KERNEL_BRANCH" ] ; then
406 if [ -z "$KERNEL_BRANCH" ] ; then
407 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
407 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
408 else
408 else
409 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
409 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
410 fi
410 fi
411
411
412 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
412 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
413 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
413 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
414 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
414 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
415 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
415 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
416 exit 1
416 exit 1
417 fi
417 fi
418 fi
418 fi
419
419
420 # Add cmake to compile videocore sources
420 # Add cmake to compile videocore sources
421 if [ "$ENABLE_VIDEOCORE" = true ] ; then
421 if [ "$ENABLE_VIDEOCORE" = true ] ; then
422 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
422 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
423 fi
423 fi
424
424
425 # Add deps for nexmon
425 # Add deps for nexmon
426 if [ "$ENABLE_NEXMON" = true ] ; then
426 if [ "$ENABLE_NEXMON" = true ] ; then
427 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
427 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
428 fi
428 fi
429
429
430 # Add libncurses5 to enable kernel menuconfig
430 # Add libncurses5 to enable kernel menuconfig
431 if [ "$KERNEL_MENUCONFIG" = true ] ; then
431 if [ "$KERNEL_MENUCONFIG" = true ] ; then
432 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
432 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
433 fi
433 fi
434
434
435 # Add ccache compiler cache for (faster) kernel cross (re)compilation
435 # Add ccache compiler cache for (faster) kernel cross (re)compilation
436 if [ "$KERNEL_CCACHE" = true ] ; then
436 if [ "$KERNEL_CCACHE" = true ] ; then
437 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
437 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
438 fi
438 fi
439
439
440 # Add cryptsetup package to enable filesystem encryption
440 # Add cryptsetup package to enable filesystem encryption
441 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
441 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
442 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
442 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
443 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
443 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
444
444
445 ## If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
445 ## If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
446 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
446 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
447 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
447 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
448 fi
448 fi
449
449
450 if [ -z "$CRYPTFS_PASSWORD" ] ; then
450 if [ -z "$CRYPTFS_PASSWORD" ] ; then
451 echo "error: no password defined (CRYPTFS_PASSWORD)!"
451 echo "error: no password defined (CRYPTFS_PASSWORD)!"
452 exit 1
452 exit 1
453 fi
453 fi
454 ENABLE_INITRAMFS=true
454 ENABLE_INITRAMFS=true
455 fi
455 fi
456
456
457 # Add initramfs generation tools
457 # Add initramfs generation tools
458 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
458 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
459 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
459 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
460 fi
460 fi
461
461
462 # Add device-tree-compiler required for building the U-Boot bootloader
462 # Add device-tree-compiler required for building the U-Boot bootloader
463 if [ "$ENABLE_UBOOT" = true ] ; then
463 if [ "$ENABLE_UBOOT" = true ] ; then
464 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
464 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
465 fi
465 fi
466
466
467 if [ "$ENABLE_USBBOOT" = true ] ; then
467 if [ "$ENABLE_USBBOOT" = true ] ; then
468 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
468 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
469 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
469 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
470 exit 1
470 exit 1
471 fi
471 fi
472 fi
472 fi
473
473
474 # Check if root SSH (v2) public key file exists
474 # Check if root SSH (v2) public key file exists
475 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
475 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
476 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
476 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
477 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
477 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
478 exit 1
478 exit 1
479 fi
479 fi
480 fi
480 fi
481
481
482 # Check if $USER_NAME SSH (v2) public key file exists
482 # Check if $USER_NAME SSH (v2) public key file exists
483 if [ -n "$SSH_USER_PUB_KEY" ] ; then
483 if [ -n "$SSH_USER_PUB_KEY" ] ; then
484 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
484 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
485 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
485 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
486 exit 1
486 exit 1
487 fi
487 fi
488 fi
488 fi
489
489
490 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
490 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
491 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
491 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
492 exit 1
492 exit 1
493 fi
493 fi
494
494
495 # Check if all required packages are installed on the build system
495 # Check if all required packages are installed on the build system
496 for package in $REQUIRED_PACKAGES ; do
496 for package in $REQUIRED_PACKAGES ; do
497 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
497 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
498 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
498 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
499 fi
499 fi
500 done
500 done
501
501
502 # If there are missing packages ask confirmation for install, or exit
502 # If there are missing packages ask confirmation for install, or exit
503 if [ -n "$MISSING_PACKAGES" ] ; then
503 if [ -n "$MISSING_PACKAGES" ] ; then
504 echo "the following packages needed by this script are not installed:"
504 echo "the following packages needed by this script are not installed:"
505 echo "$MISSING_PACKAGES"
505 echo "$MISSING_PACKAGES"
506
506
507 printf "\ndo you want to install the missing packages right now? [y/n] "
507 printf "\ndo you want to install the missing packages right now? [y/n] "
508 read -r confirm
508 read -r confirm
509 [ "$confirm" != "y" ] && exit 1
509 [ "$confirm" != "y" ] && exit 1
510
510
511 ## Make sure all missing required packages are installed
511 ## Make sure all missing required packages are installed
512 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
512 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
513 fi
513 fi
514
514
515 # Check if ./bootstrap.d directory exists
515 # Check if ./bootstrap.d directory exists
516 if [ ! -d "./bootstrap.d/" ] ; then
516 if [ ! -d "./bootstrap.d/" ] ; then
517 echo "error: './bootstrap.d' required directory not found!"
517 echo "error: './bootstrap.d' required directory not found!"
518 exit 1
518 exit 1
519 fi
519 fi
520
520
521 # Check if ./files directory exists
521 # Check if ./files directory exists
522 if [ ! -d "./files/" ] ; then
522 if [ ! -d "./files/" ] ; then
523 echo "error: './files' required directory not found!"
523 echo "error: './files' required directory not found!"
524 exit 1
524 exit 1
525 fi
525 fi
526
526
527 # Check if specified KERNELSRC_DIR directory exists
527 # Check if specified KERNELSRC_DIR directory exists
528 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
528 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
529 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
529 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
530 exit 1
530 exit 1
531 fi
531 fi
532
532
533 # Check if specified UBOOTSRC_DIR directory exists
533 # Check if specified UBOOTSRC_DIR directory exists
534 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
534 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
535 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
535 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
536 exit 1
536 exit 1
537 fi
537 fi
538
538
539 # Check if specified VIDEOCORESRC_DIR directory exists
539 # Check if specified VIDEOCORESRC_DIR directory exists
540 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
540 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
541 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
541 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
542 exit 1
542 exit 1
543 fi
543 fi
544
544
545 # Check if specified FBTURBOSRC_DIR directory exists
545 # Check if specified FBTURBOSRC_DIR directory exists
546 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
546 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
547 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
547 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
548 exit 1
548 exit 1
549 fi
549 fi
550
550
551 # Check if specified NEXMONSRC_DIR directory exists
551 # Check if specified NEXMONSRC_DIR directory exists
552 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
552 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
553 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
553 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
554 exit 1
554 exit 1
555 fi
555 fi
556
556
557 # Check if specified CHROOT_SCRIPTS directory exists
557 # Check if specified CHROOT_SCRIPTS directory exists
558 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
558 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
559 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
559 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
560 exit 1
560 exit 1
561 fi
561 fi
562
562
563 # Check if specified device mapping already exists (will be used by cryptsetup)
563 # Check if specified device mapping already exists (will be used by cryptsetup)
564 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
564 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
565 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
565 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
566 exit 1
566 exit 1
567 fi
567 fi
568
568
569 # Don't clobber an old build
569 # Don't clobber an old build
570 if [ -e "$BUILDDIR" ] ; then
570 if [ -e "$BUILDDIR" ] ; then
571 echo "error: directory ${BUILDDIR} already exists, not proceeding"
571 echo "error: directory ${BUILDDIR} already exists, not proceeding"
572 exit 1
572 exit 1
573 fi
573 fi
574
574
575 # Setup chroot directory
575 # Setup chroot directory
576 mkdir -p "${R}"
576 mkdir -p "${R}"
577
577
578 # Check if build directory has enough of free disk space >512MB
578 # Check if build directory has enough of free disk space >512MB
579 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
579 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
580 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
580 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
581 exit 1
581 exit 1
582 fi
582 fi
583
583
584 set -x
584 set -x
585
585
586 # Call "cleanup" function on various signals and errors
586 # Call "cleanup" function on various signals and errors
587 trap cleanup 0 1 2 3 6
587 trap cleanup 0 1 2 3 6
588
588
589 # Add required packages for the minbase installation
589 # Add required packages for the minbase installation
590 if [ "$ENABLE_MINBASE" = true ] ; then
590 if [ "$ENABLE_MINBASE" = true ] ; then
591 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
591 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
592 fi
592 fi
593
593
594 # Add parted package, required to get partprobe utility
594 # Add parted package, required to get partprobe utility
595 if [ "$EXPANDROOT" = true ] ; then
595 if [ "$EXPANDROOT" = true ] ; then
596 APT_INCLUDES="${APT_INCLUDES},parted"
596 APT_INCLUDES="${APT_INCLUDES},parted"
597 fi
597 fi
598
598
599 # Add dphys-swapfile package, required to enable swap
599 # Add dphys-swapfile package, required to enable swap
600 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
600 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
601 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
601 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
602 fi
602 fi
603
603
604 # Add dbus package, recommended if using systemd
604 # Add dbus package, recommended if using systemd
605 if [ "$ENABLE_DBUS" = true ] ; then
605 if [ "$ENABLE_DBUS" = true ] ; then
606 APT_INCLUDES="${APT_INCLUDES},dbus"
606 APT_INCLUDES="${APT_INCLUDES},dbus"
607 fi
607 fi
608
608
609 # Add iptables IPv4/IPv6 package
609 # Add iptables IPv4/IPv6 package
610 if [ "$ENABLE_IPTABLES" = true ] ; then
610 if [ "$ENABLE_IPTABLES" = true ] ; then
611 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
611 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
612 fi
612 fi
613 # Add apparmor for KERNEL_SECURITY
613 # Add apparmor for KERNEL_SECURITY
614 if [ "$KERNEL_SECURITY" = true ] ; then
614 if [ "$KERNEL_SECURITY" = true ] ; then
615 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
615 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
616 fi
616 fi
617
617
618 # Add openssh server package
618 # Add openssh server package
619 if [ "$SSH_ENABLE" = true ] ; then
619 if [ "$SSH_ENABLE" = true ] ; then
620 APT_INCLUDES="${APT_INCLUDES},openssh-server"
620 APT_INCLUDES="${APT_INCLUDES},openssh-server"
621 fi
621 fi
622
622
623 # Add alsa-utils package
623 # Add alsa-utils package
624 if [ "$ENABLE_SOUND" = true ] ; then
624 if [ "$ENABLE_SOUND" = true ] ; then
625 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
625 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
626 fi
626 fi
627
627
628 # Add rng-tools package
628 # Add rng-tools package
629 if [ "$ENABLE_HWRANDOM" = true ] ; then
629 if [ "$ENABLE_HWRANDOM" = true ] ; then
630 APT_INCLUDES="${APT_INCLUDES},rng-tools"
630 APT_INCLUDES="${APT_INCLUDES},rng-tools"
631 fi
631 fi
632
632
633 # Add fbturbo video driver
633 # Add fbturbo video driver
634 if [ "$ENABLE_FBTURBO" = true ] ; then
634 if [ "$ENABLE_FBTURBO" = true ] ; then
635 # Enable xorg package dependencies
635 # Enable xorg package dependencies
636 ENABLE_XORG=true
636 ENABLE_XORG=true
637 fi
637 fi
638
638
639 # Add user defined window manager package
639 # Add user defined window manager package
640 if [ -n "$ENABLE_WM" ] ; then
640 if [ -n "$ENABLE_WM" ] ; then
641 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
641 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
642
642
643 # Enable xorg package dependencies
643 # Enable xorg package dependencies
644 ENABLE_XORG=true
644 ENABLE_XORG=true
645 fi
645 fi
646
646
647 # Add xorg package
647 # Add xorg package
648 if [ "$ENABLE_XORG" = true ] ; then
648 if [ "$ENABLE_XORG" = true ] ; then
649 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
649 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
650 fi
650 fi
651
651
652 # Replace selected packages with smaller clones
652 # Replace selected packages with smaller clones
653 if [ "$ENABLE_REDUCE" = true ] ; then
653 if [ "$ENABLE_REDUCE" = true ] ; then
654 ## Add levee package instead of vim-tiny
654 ## Add levee package instead of vim-tiny
655 if [ "$REDUCE_VIM" = true ] ; then
655 if [ "$REDUCE_VIM" = true ] ; then
656 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
656 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
657 fi
657 fi
658
658
659 ## Add dropbear package instead of openssh-server
659 ## Add dropbear package instead of openssh-server
660 if [ "$REDUCE_SSHD" = true ] ; then
660 if [ "$REDUCE_SSHD" = true ] ; then
661 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
661 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
662 fi
662 fi
663 fi
663 fi
664
664
665 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
665 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
666 if [ "$ENABLE_SYSVINIT" = false ] ; then
666 if [ "$ENABLE_SYSVINIT" = false ] ; then
667 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
667 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
668 fi
668 fi
669
669
670 # Configure kernel sources if no KERNELSRC_DIR
670 # Configure kernel sources if no KERNELSRC_DIR
671 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
671 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
672 KERNELSRC_CONFIG=true
672 KERNELSRC_CONFIG=true
673 fi
673 fi
674
674
675 # Configure reduced kernel
675 # Configure reduced kernel
676 if [ "$KERNEL_REDUCE" = true ] ; then
676 if [ "$KERNEL_REDUCE" = true ] ; then
677 KERNELSRC_CONFIG=false
677 KERNELSRC_CONFIG=false
678 fi
678 fi
679
679
680 # Configure qemu compatible kernel
680 # Configure qemu compatible kernel
681 if [ "$ENABLE_QEMU" = true ] ; then
681 if [ "$ENABLE_QEMU" = true ] ; then
682 DTB_FILE=vexpress-v2p-ca15_a7.dtb
682 DTB_FILE=vexpress-v2p-ca15_a7.dtb
683 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
683 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
684 KERNEL_DEFCONFIG="vexpress_defconfig"
684 KERNEL_DEFCONFIG="vexpress_defconfig"
685 if [ "$KERNEL_MENUCONFIG" = false ] ; then
685 if [ "$KERNEL_MENUCONFIG" = false ] ; then
686 KERNEL_OLDDEFCONFIG=true
686 KERNEL_OLDDEFCONFIG=true
687 fi
687 fi
688 fi
688 fi
689
689
690 # Execute bootstrap scripts
690 # Execute bootstrap scripts
691 for SCRIPT in bootstrap.d/*.sh; do
691 for SCRIPT in bootstrap.d/*.sh; do
692 head -n 3 "$SCRIPT"
692 head -n 3 "$SCRIPT"
693 . "$SCRIPT"
693 . "$SCRIPT"
694 done
694 done
695
695
696 ## Execute custom bootstrap scripts
696 ## Execute custom bootstrap scripts
697 if [ -d "custom.d" ] ; then
697 if [ -d "custom.d" ] ; then
698 for SCRIPT in custom.d/*.sh; do
698 for SCRIPT in custom.d/*.sh; do
699 . "$SCRIPT"
699 . "$SCRIPT"
700 done
700 done
701 fi
701 fi
702
702
703 # Execute custom scripts inside the chroot
703 # Execute custom scripts inside the chroot
704 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
704 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
705 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
705 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
706 chroot_exec /bin/bash -x <<'EOF'
706 chroot_exec /bin/bash -x << EOF
707 for SCRIPT in /chroot_scripts/* ; do
707 for SCRIPT in /chroot_scripts/* ; do
708 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
708 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
709 $SCRIPT
709 $SCRIPT
710 fi
710 fi
711 done
711 done
712 EOF
712 EOF
713 rm -rf "${R}/chroot_scripts"
713 rm -rf "${R}/chroot_scripts"
714 fi
714 fi
715
715
716 # Remove c/c++ build environment from the chroot
716 # Remove c/c++ build environment from the chroot
717 chroot_remove_cc
717 chroot_remove_cc
718
718
719 # Generate required machine-id
719 # Generate required machine-id
720 MACHINE_ID=$(dbus-uuidgen)
720 MACHINE_ID=$(dbus-uuidgen)
721 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
721 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
722 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
722 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
723
723
724 # APT Cleanup
724 # APT Cleanup
725 chroot_exec apt-get -y clean
725 chroot_exec apt-get -y clean
726 chroot_exec apt-get -y autoclean
726 chroot_exec apt-get -y autoclean
727 chroot_exec apt-get -y autoremove
727 chroot_exec apt-get -y autoremove
728
728
729 # Unmount mounted filesystems
729 # Unmount mounted filesystems
730 umount -l "${R}/proc"
730 umount -l "${R}/proc"
731 umount -l "${R}/sys"
731 umount -l "${R}/sys"
732
732
733 # Clean up directories
733 # Clean up directories
734 rm -rf "${R}/run/*"
734 rm -rf "${R}/run/*"
735 rm -rf "${R}/tmp/*"
735 rm -rf "${R}/tmp/*"
736
736
737 # Clean up APT proxy settings
737 # Clean up APT proxy settings
738 if [ "$KEEP_APT_PROXY" = false ] ; then
738 if [ "$KEEP_APT_PROXY" = false ] ; then
739 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
739 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
740 fi
740 fi
741
741
742 # Clean up files
742 # Clean up files
743 rm -f "${ETC_DIR}/ssh/ssh_host_*"
743 rm -f "${ETC_DIR}/ssh/ssh_host_*"
744 rm -f "${ETC_DIR}/dropbear/dropbear_*"
744 rm -f "${ETC_DIR}/dropbear/dropbear_*"
745 rm -f "${ETC_DIR}/apt/sources.list.save"
745 rm -f "${ETC_DIR}/apt/sources.list.save"
746 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
746 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
747 rm -f "${ETC_DIR}/*-"
747 rm -f "${ETC_DIR}/*-"
748 rm -f "${ETC_DIR}/resolv.conf"
748 rm -f "${ETC_DIR}/resolv.conf"
749 rm -f "${R}/root/.bash_history"
749 rm -f "${R}/root/.bash_history"
750 rm -f "${R}/var/lib/urandom/random-seed"
750 rm -f "${R}/var/lib/urandom/random-seed"
751 rm -f "${R}/initrd.img"
751 rm -f "${R}/initrd.img"
752 rm -f "${R}/vmlinuz"
752 rm -f "${R}/vmlinuz"
753 rm -f "${R}${QEMU_BINARY}"
753 rm -f "${R}${QEMU_BINARY}"
754
754
755 if [ "$ENABLE_QEMU" = true ] ; then
755 if [ "$ENABLE_QEMU" = true ] ; then
756 # Setup QEMU directory
756 # Setup QEMU directory
757 mkdir "${BASEDIR}/qemu"
757 mkdir "${BASEDIR}/qemu"
758
758
759 # Copy kernel image to QEMU directory
759 # Copy kernel image to QEMU directory
760 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
760 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
761
761
762 # Copy kernel config to QEMU directory
762 # Copy kernel config to QEMU directory
763 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
763 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
764
764
765 # Copy kernel dtbs to QEMU directory
765 # Copy kernel dtbs to QEMU directory
766 for dtb in "${BOOT_DIR}/"*.dtb ; do
766 for dtb in "${BOOT_DIR}/"*.dtb ; do
767 if [ -f "${dtb}" ] ; then
767 if [ -f "${dtb}" ] ; then
768 install_readonly "${dtb}" "${BASEDIR}/qemu/"
768 install_readonly "${dtb}" "${BASEDIR}/qemu/"
769 fi
769 fi
770 done
770 done
771
771
772 # Copy kernel overlays to QEMU directory
772 # Copy kernel overlays to QEMU directory
773 if [ -d "${BOOT_DIR}/overlays" ] ; then
773 if [ -d "${BOOT_DIR}/overlays" ] ; then
774 # Setup overlays dtbs directory
774 # Setup overlays dtbs directory
775 mkdir "${BASEDIR}/qemu/overlays"
775 mkdir "${BASEDIR}/qemu/overlays"
776
776
777 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
777 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
778 if [ -f "${dtb}" ] ; then
778 if [ -f "${dtb}" ] ; then
779 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
779 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
780 fi
780 fi
781 done
781 done
782 fi
782 fi
783
783
784 # Copy u-boot files to QEMU directory
784 # Copy u-boot files to QEMU directory
785 if [ "$ENABLE_UBOOT" = true ] ; then
785 if [ "$ENABLE_UBOOT" = true ] ; then
786 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
786 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
787 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
787 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
788 fi
788 fi
789 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
789 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
790 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
790 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
791 fi
791 fi
792 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
792 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
793 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
793 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
794 fi
794 fi
795 fi
795 fi
796
796
797 # Copy initramfs to QEMU directory
797 # Copy initramfs to QEMU directory
798 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
798 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
799 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
799 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
800 fi
800 fi
801 fi
801 fi
802
802
803 # Calculate size of the chroot directory in KB
803 # Calculate size of the chroot directory in KB
804 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
804 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
805
805
806 # Calculate the amount of needed 512 Byte sectors
806 # Calculate the amount of needed 512 Byte sectors
807 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
807 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
808 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
808 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
809 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
809 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
810
810
811 # The root partition is EXT4
811 # The root partition is EXT4
812 # This means more space than the actual used space of the chroot is used.
812 # This means more space than the actual used space of the chroot is used.
813 # As overhead for journaling and reserved blocks 35% are added.
813 # As overhead for journaling and reserved blocks 35% are added.
814 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
814 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
815
815
816 # Calculate required image size in 512 Byte sectors
816 # Calculate required image size in 512 Byte sectors
817 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
817 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
818
818
819 # Prepare image file
819 # Prepare image file
820 if [ "$ENABLE_SPLITFS" = true ] ; then
820 if [ "$ENABLE_SPLITFS" = true ] ; then
821 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
821 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
822 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
822 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
823 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
823 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
824 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
824 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
825
825
826 # Write firmware/boot partition tables
826 # Write firmware/boot partition tables
827 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
827 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null << EOM
828 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
828 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
829 EOM
829 EOM
830
830
831 # Write root partition table
831 # Write root partition table
832 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
832 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null << EOM
833 ${TABLE_SECTORS},${ROOT_SECTORS},83
833 ${TABLE_SECTORS},${ROOT_SECTORS},83
834 EOM
834 EOM
835
835
836 # Setup temporary loop devices
836 # Setup temporary loop devices
837 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
837 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
838 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
838 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
839 else # ENABLE_SPLITFS=false
839 else # ENABLE_SPLITFS=false
840 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
840 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
841 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
841 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
842
842
843 # Write partition table
843 # Write partition table
844 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
844 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null << EOM
845 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
845 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
846 ${ROOT_OFFSET},${ROOT_SECTORS},83
846 ${ROOT_OFFSET},${ROOT_SECTORS},83
847 EOM
847 EOM
848
848
849 # Setup temporary loop devices
849 # Setup temporary loop devices
850 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
850 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
851 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
851 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
852 fi
852 fi
853
853
854 if [ "$ENABLE_CRYPTFS" = true ] ; then
854 if [ "$ENABLE_CRYPTFS" = true ] ; then
855 # Create dummy ext4 fs
855 # Create dummy ext4 fs
856 mkfs.ext4 "$ROOT_LOOP"
856 mkfs.ext4 "$ROOT_LOOP"
857
857
858 # Setup password keyfile
858 # Setup password keyfile
859 touch .password
859 touch .password
860 chmod 600 .password
860 chmod 600 .password
861 echo -n ${CRYPTFS_PASSWORD} > .password
861 echo -n ${CRYPTFS_PASSWORD} > .password
862
862
863 # Initialize encrypted partition
863 # Initialize encrypted partition
864 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
864 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
865
865
866 # Open encrypted partition and setup mapping
866 # Open encrypted partition and setup mapping
867 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
867 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
868
868
869 # Secure delete password keyfile
869 # Secure delete password keyfile
870 shred -zu .password
870 shred -zu .password
871
871
872 # Update temporary loop device
872 # Update temporary loop device
873 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
873 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
874
874
875 # Wipe encrypted partition (encryption cipher is used for randomness)
875 # Wipe encrypted partition (encryption cipher is used for randomness)
876 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
876 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
877 fi
877 fi
878
878
879 # Build filesystems
879 # Build filesystems
880 mkfs.vfat "$FRMW_LOOP"
880 mkfs.vfat "$FRMW_LOOP"
881 mkfs.ext4 "$ROOT_LOOP"
881 mkfs.ext4 "$ROOT_LOOP"
882
882
883 # Mount the temporary loop devices
883 # Mount the temporary loop devices
884 mkdir -p "$BUILDDIR/mount"
884 mkdir -p "$BUILDDIR/mount"
885 mount "$ROOT_LOOP" "$BUILDDIR/mount"
885 mount "$ROOT_LOOP" "$BUILDDIR/mount"
886
886
887 mkdir -p "$BUILDDIR/mount/boot/firmware"
887 mkdir -p "$BUILDDIR/mount/boot/firmware"
888 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
888 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
889
889
890 # Copy all files from the chroot to the loop device mount point directory
890 # Copy all files from the chroot to the loop device mount point directory
891 rsync -a "${R}/" "$BUILDDIR/mount/"
891 rsync -a "${R}/" "$BUILDDIR/mount/"
892
892
893 # Unmount all temporary loop devices and mount points
893 # Unmount all temporary loop devices and mount points
894 cleanup
894 cleanup
895
895
896 # Create block map file(s) of image(s)
896 # Create block map file(s) of image(s)
897 if [ "$ENABLE_SPLITFS" = true ] ; then
897 if [ "$ENABLE_SPLITFS" = true ] ; then
898 # Create block map files for "bmaptool"
898 # Create block map files for "bmaptool"
899 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
899 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
900 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
900 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
901
901
902 # Image was successfully created
902 # Image was successfully created
903 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
903 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
904 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
904 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
905 else
905 else
906 # Create block map file for "bmaptool"
906 # Create block map file for "bmaptool"
907 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
907 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
908
908
909 # Image was successfully created
909 # Image was successfully created
910 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
910 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
911
911
912 # Create qemu qcow2 image
912 # Create qemu qcow2 image
913 if [ "$ENABLE_QEMU" = true ] ; then
913 if [ "$ENABLE_QEMU" = true ] ; then
914 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
914 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
915 QEMU_SIZE=16G
915 QEMU_SIZE=16G
916
916
917 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
917 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
918 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
918 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
919
919
920 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
920 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
921 fi
921 fi
922 fi
922 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant